--[[
FLIGHT MODE TOGGLE FOR FS25
by Sablerock
date written: 2024/11/15
Changelog:
Date:
]]

FlightMode = {}

addModEventListener(FlightMode)

executeConsoleCommand = Utils.overwrittenFunction(executeConsoleCommand,
function(command, superFunc, ...)

	superFunc(command, ...)
end
)

PlayerInputComponent.registerGlobalPlayerActionEvents = Utils.appendedFunction(PlayerInputComponent.registerGlobalPlayerActionEvents, function()

    local triggerUp, triggerDown, triggerAlways, startActive, callbackState, disableConflictingBindings = false, true, false, true, nil, true
	local success, actionEventId, otherEvents = g_inputBinding:registerActionEvent('TOGGLEFLIGHT', FlightMode, FlightMode.toggleFlight, triggerUp, triggerDown, triggerAlways, startActive, callbackState, disableConflictingBindings)
	
    if success then
		print("Flightmode: registerActionEvent success = " .. tostring(success))
        FlightMode.actionEventId = actionEventId
        g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_VERY_HIGH)
    else
        print("Failed to register action key for FlightMode ,success="..tostring(success).." ,actionId=", actionEventId)
    end    

	g_inputBinding:setActionEventActive(actionEventId, true)
	g_inputBinding:setActionEventTextVisibility(actionEventId, true)
	
end)

function FlightMode:loadMap(name)
	if not g_startMissionInfo.isMultiplayer then
		print("FlightMode console command is enabled for single player")
	else
		print("FlightMode console command is disabled for multiplayer")
	end
end

function FlightMode:toggleFlight()
	executeConsoleCommand('gsPlayerFlightToggle')
    if g_localPlayer.toggleFlightModeCommand.value then
        g_currentMission:addGameNotification(g_i18n:getText("flightMode"), g_i18n:getText("enabled"), g_i18n:getText("flightModeUsage"), nil, 2500)
    else
        g_currentMission:addGameNotification(g_i18n:getText("flightMode"), g_i18n:getText("disabled"), "", nil, 1500)
    end
end

